﻿using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using UnityEngine;
using UnityEngine.EventSystems;
using UnityEngine.UI;

public class TrackManager : MonoBehaviour {
    [SerializeField]
    GameObject trackList;

    [SerializeField]
    GameObject trackItemPrefab;

    [SerializeField]
    Texture2D[] backgrounds;
    private int currentBackgroundIndex = 0;

    private GameObject selectedTrackItem = null;

    private void TrackBrowse()
    {
        currentBackgroundIndex = (currentBackgroundIndex + 1) % 2;
        trackList.GetComponent<RawImage>().texture = backgrounds[currentBackgroundIndex];

        GameManager.Instance.CurrentTrack = trackList.transform.GetChild(2).GetComponent<TrackInfoHolder>().trackInfo;
        Debug.Log(GameManager.Instance.CurrentTrack.Title);
    }

    // Use this for initialization
    void Start()
    {
        LoadTracks();
    }
	
    // Update is called once per frame
    void Update()
    {
        if (Input.GetKeyDown(KeyCode.DownArrow))
        {
            trackList.transform.GetChild(0).SetAsLastSibling();
            TrackBrowse();
        }
        if (Input.GetKeyDown(KeyCode.UpArrow))
        {
            trackList.transform.GetChild(trackList.transform.childCount - 1).SetAsFirstSibling();
            TrackBrowse();
        }
    }
    
    void LoadTracks()
    {
        var files = new DirectoryInfo("Assets/Tracks")
            .GetFiles("*.bpe", SearchOption.AllDirectories);

        TrackInfo[] tracks = files.Select(s => new TrackInfo(s)).ToArray();

        foreach (TrackInfo track in tracks)
        {
            var trackItem = Instantiate(trackItemPrefab, trackList.transform);
//            trackItem.transform.SetParent(trackList.transform);

            trackItem.AddComponent<TrackInfoHolder>().trackInfo = track;
        }
    }

    public void StartTrack()
    {
        // TODO: disable start button if nothing selected

        var holder = selectedTrackItem.GetComponent<TrackInfoHolder>();

        GameManager.Instance.CurrentTrack = holder.trackInfo;

        GameManager.Instance.SceneTransition("InGame");
    }
}